import pino from 'pino';
import { Env } from './configSystem/base';
export type LoggerTransportConfig = {
    file?: {
        enabled: boolean;
        destination: string;
    };
    console?: {
        enabled: boolean;
    };
    datadog?: {
        enabled: boolean;
        apiKey: string;
        eu: boolean;
    };
};
export type LoggerConfig = {
    name: string;
    env: Env;
    productionConsole?: boolean;
    transports: LoggerTransportConfig;
};
export type Logger = pino.Logger;
export { pino };
export declare const init: (config: LoggerConfig) => pino.Logger;
