import * as types from '../types';
export type HashFunction = (...args: Array<types.Jsonable>) => string;
export declare const hashJson: HashFunction;
type MaybePromise<T> = Promise<T> | T;
export declare const isPromise: (something: any) => something is Promise<any>;
export declare const ensurePromise: <T>(maybePromise: MaybePromise<T>) => Promise<T>;
export declare const series: <T>(array: MaybePromise<T>[]) => Promise<T[]>;
export declare const flow: (...array: Array<Function>) => (result: any) => Promise<any>;
export declare const maybePromiseResolve: <T>(val: types.MaybePromise<T>) => Promise<T>;
export type ResolvableProps<T> = object & {
    [K in keyof T]: types.MaybePromise<T[K]>;
};
export declare const propsResolveSeries: <T>(dict: ResolvableProps<T>) => Promise<T>;
export declare const propsResolve: <T>(dict: ResolvableProps<T>) => Promise<T>;
export declare const cache: <ARGS extends any[], RET extends types.Jsonable>(store: types.KVStore<any>, hash?: HashFunction) => (f: (...args: ARGS) => Promise<RET>) => (...args: ARGS) => Promise<unknown>;
export declare const delay: <T>(n: number, f: () => Promise<T>) => () => Promise<T>;
export declare const times: <T>(n: number, f: () => Promise<T>) => Promise<T[]>;
export {};
